/* http.h -- Dune Webserver
 * Copyright (C) 1998 Baris Mestanogullari <mestanba@martin.luther.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HTTP_H
#define HTTP_H

/* Define return values */
#define E_NOENT  1
#define E_ACCES  2
#define IS_FILE  3
#define IS_DIR   4
/* End return values */

extern void sendBadRequest(int);
extern void sendNotFound(char *, int);
extern void sendForbidden(char *, int);
extern void sendMovedPermanently(char *, int);
extern void sendNotImplemented();
extern void sendFile(char *, int);
extern void sendContentInfo(char *);
extern void sendIndex(char *, char *, int);
extern void LOG(char *, char *, int);

extern char *buffer;
extern int cfd;
FILE *urlp;

struct filetype
{
  char *extension, *type;
};

struct filetype types[] =
{
  { ".abs", "audio/x-mpeg" },
  { ".bin", "application/octet-stream" },
  { ".bmp", "image/x-MS-bmp" },
  { ".com", "application/octet-stream" },
  { ".dll", "application/octet-stream" },
  { ".exe", "application/octet-stream" },
  { ".gif", "image/gif" },
  { ".htm", "text/html" },
  { ".html", "text/html" },
  { ".jpg", "image/jpeg" },
  { ".jpeg", "image/jpeg" },
  { ".mid", "audio/x-midi" },
  { ".midi", "audio/x-midi" },
  { ".mp2", "audio/x-mpeg" },
  { ".mp3", "audio/x-mpeg" },
  { ".mpa", "audio/x-mpeg" },
  { ".mpe", "video/mpeg" },
  { ".mpeg", "video/mpeg" },
  { ".mpega", "audio/x-mpeg" },
  { ".mpegv", "video/mpeg" },
  { ".mpg", "video/mpeg" },
  { ".mpv", "video/mpeg" },
  { ".png", "image/png" },
  { ".ra", "audio/x-pn-realaudio" },
  { ".ram", "audio/x-pn-realaudio" },
  { ".sys", "application/octet-stream" },
  { ".tar", "application/x-tar" },
  { ".txt", "text/plain" },
  { ".vbs", "video/mpeg" },
  { ".wav", "audio/x-wav" },
  { ".xbm", "image/x-xbitmap" },
  { ".zip", "application/x-zip" },
  { NULL, NULL }
};

#endif
